//+------------------------------------------------------------------+
//|                                                        Drive.mq4 |
//|                                       Copyright  2005, systrad5 |
//|                                                         25/07/05 |
//|               Feedback or comments welcome at systrad5@yahoo.com |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
//---- input parameters
extern int Depth = 16;
extern int timeFrame=0;
//---- buffers
double UpBuffer[];
double DownBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//---- additional buffers
   timeFrame =  MathMax(timeFrame,Period());
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, UpBuffer);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, DownBuffer);
   //---- name for DataWindow and indicator subwindow label
   string short_name = "Drive(" + Depth + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, "DriveUp");
   SetIndexLabel(1, "DriveDn");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, j;
   double UpCnt, DnCnt;      
   if(Bars <= Depth + 10) 
       return(0);
//---- last counted bar will be recounted
   int counted_bars = IndicatorCounted();
   int limit = Bars - counted_bars;
   if(counted_bars > 0) 
       limit++; limit = MathMin(MathMax(limit,2*timeFrame/Period()),Bars-1);
//---- Load prices into CBuffer[0]
   for(i = limit; i >=0; i--)
     {
       UpCnt = 0;
       DnCnt = 0;
       int y = iBarShift(NULL,timeFrame,Time[i]);
       for(j = 0; j < Depth; j++)
         {
           UpCnt = UpCnt + (iHigh(NULL,timeFrame,y+j) - iOpen(NULL,timeFrame,y+j)) + (iClose(NULL,timeFrame,y+j) - iLow(NULL,timeFrame,y+j));
           DnCnt = DnCnt + (iOpen(NULL,timeFrame,y+j) - iLow(NULL,timeFrame,y+j)) + (iHigh(NULL,timeFrame,y+j) - iClose(NULL,timeFrame,y+j));
         }
       UpBuffer[i] = (UpCnt / (2 * Depth)) / Point;
       DownBuffer[i] = (DnCnt / (2 * Depth)) / Point;
     }
   return(0);
  }
//+------------------------------------------------------------------+

